"""
Django settings for project.

Generated by 'django-admin startproject' using Django 1.11.7.

For more information on this file, see
https://docs.djangoproject.com/en/1.11/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.11/ref/settings/
"""

import os

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/1.11/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'hl$bc0@m&kv4j75y=$n3%p-jn91_$@-5u))z2z5-gezyv)eva2'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = ['aija.ga',
                 'solr',
                 'localhost'
]

AUTH_USER_MODEL = 'users.User'

# Application definition

INSTALLED_APPS = [
    #manually added
    'shops', #for shops handling
    'sortiment', #for base sortiment handling (all products available)
    'searching', #main front-end website
    'categories', #categories for products
    'users', #extends default user class
    'shopsortiment', #for sortiment available in shops handling
    
    'haystack', #for handling Solr
    'imagekit', #for handling images
    'import_export', #for data import from csv
    'widget_tweaks', #for input fields rendering

    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',

]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'main.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [
            os.path.join(BASE_DIR, 'templates'),
        ],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'main.wsgi.application'


# Database
# https://docs.djangoproject.com/en/1.11/ref/settings/#databases
# create database drinks;
# CREATE USER webs WITH PASSWORD 'zS{/xfR@D&4B,)YD';
# ALTER ROLE webs SET client_encoding TO 'utf8';
# ALTER ROLE webs SET default_transaction_isolation TO 'read committed';
# ALTER ROLE webs SET timezone TO 'UTC';
# GRANT ALL PRIVILEGES ON DATABASE drinks TO webs;
# ALTER DATABASE drinks OWNER TO webs;
DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.postgresql',
        'NAME': 'drinks',
        'USER': 'webs',
        'PASSWORD': 'zS{/xfR@D&4B,)YD',
        'HOST': 'dbase',
        'PORT': 5432,
    }
}


# Password validation
# https://docs.djangoproject.com/en/1.11/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/1.11/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'EET'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.11/howto/static-files/

STATIC_URL = '/static/'

# for interacting with Solr
HAYSTACK_CONNECTIONS = {
    'default': {
        'ENGINE': 'haystack.backends.solr_backend.SolrEngine',
        'URL': 'http://solr:8983/solr/sortiment'
        # ...or for multicore...
        # 'URL': 'http://127.0.0.1:8983/solr/mysite',
    },
}

#HAYSTACK_ID_FIELD = 1

#DJANGO_SETTINGS_MODULE = 'easydrinks.settings'

STATICFILES_DIRS = [
    os.path.join(BASE_DIR, "static"),
]

# media files are mapped from volumes
MEDIA_ROOT = "/media/"
MEDIA_URL = "/media/"

#logged in users redirect page
LOGIN_REDIRECT_URL = '/users/profile'
LOGOUT_REDIRECT_URL = 'home'
